SystemOrganization addCategory: #LoadOrderTests!

!WriteStream methodsFor: '*loadordertests' stamp: 'jgf 2/6/2009 12:01'!
show: aString

	^self nextPutAll: aString.
	! !

Object subclass: #SeasideLoadOrderTests
	instanceVariableNames: 'userName password komHttpServer baseTests baseUndeclared doTests seaside30 versions currentVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LoadOrderTests'!

!SeasideLoadOrderTests commentStamp: 'jgf 2/6/2009 12:08' prior: 0!
SeasideLoadOrderTests provides a single class that loads the packages described on the LoadOrder Wiki (http://code.google.com/p/seaside/wiki/LoadOrder), and shows the errors and undefined along the way.!

!SeasideLoadOrderTests class methodsFor: 'initialization' stamp: 'tbn 9/2/2009 23:10'!
initialize

	(UIManager default confirm: 'Load Seaside 3.0?') ifTrue: [
		self new doLoad.
	].
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 3/15/2010 16:35'!
adminToolsPackages

	^OrderedCollection new
		add: seaside30 -> 'Seaside-Tools-OmniBrowser-lr.14.mcz';
		add: seaside30 -> 'Seaside-Pharo-Tools-OmniBrowser-lr.5.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'private' stamp: 'obi 9/6/2009 20:10'!
askForTesting
	doTests := UIManager default confirm: 'Run tests as packages are loaded?'.
	doTests ifTrue: [
		baseTests := TestCase suite tests.
		baseUndeclared := Undeclared keys.
	].! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 3/15/2010 16:36'!
basicPackages

	^OrderedCollection new
		"Platform"
		add: (Array 
			with: seaside30 -> 'Grease-Core-obi.30.mcz'
			with: seaside30 -> 'Grease-Pharo-Core-pmm.13.mcz'
			with: seaside30 -> 'Grease-Tests-Core-pmm.39.mcz'
			with: seaside30 -> 'Grease-Tests-Pharo-Core-lr.6.mcz');
		"Core"
		add: (Array 
			with: seaside30 -> 'Seaside-Core-pmm.626.mcz'
			with: seaside30 -> 'Seaside-Pharo-Core-lr.5.mcz'
			with: seaside30 -> 'Seaside-Tests-Core-lr.187.mcz'
			with: seaside30 -> 'Seaside-Tests-UTF8-lr.8.mcz'
			with: seaside30 -> 'Seaside-Tests-Pharo-Core-lr.8.mcz');
		"Canvas"
		add: (Array 
			with: seaside30 -> 'Seaside-Canvas-lr.94.mcz'
			with: seaside30 -> 'Seaside-Pharo-Canvas-lr.3.mcz'
			with: seaside30 -> 'Seaside-Tests-Canvas-lr.46.mcz');
		"Session"
		add: (Array 
			with: seaside30 -> 'Seaside-Session-jf.130.mcz'
			with: seaside30 -> 'Seaside-Tests-Session-lr.36.mcz');
		"Component"
		add: (Array 
			with: seaside30 -> 'Seaside-Component-lr.82.mcz'
			with: seaside30 -> 'Seaside-Tests-Component-lr.28.mcz');
		"RenderLoop"
		add: (Array 
			with: seaside30 -> 'Seaside-RenderLoop-lr.72.mcz'
			with: seaside30 -> 'Seaside-Tests-RenderLoop-lr.11.mcz');
		"Tools"
		add: (Array
			with: seaside30 -> 'Seaside-Tools-Core-lr.17.mcz');
		"Widgets"
		add: (Array
			with: seaside30 -> 'Seaside-Widgets-lr.16.mcz');
		"Environment"
		add: (Array 
			with: seaside30 -> 'Seaside-Environment-lr.69.mcz'
			with: seaside30 -> 'Seaside-Pharo-Environment-lr.6.mcz'
			with: seaside30 -> 'Seaside-Tests-Environment-lr.22.mcz');
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'repositories' stamp: 'obi 9/6/2009 20:23'!
cacheRepositories
	seaside30 := self seaside30.
	self cacheVersionsFor: seaside30.
	komHttpServer := self komHttpServer.
	self cacheVersionsFor: komHttpServer.! !

!SeasideLoadOrderTests methodsFor: 'private' stamp: 'obi 9/6/2009 19:56'!
cacheVersionsFor: aRepository
	self versions at: aRepository put: aRepository allVersionNames! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 3/15/2010 16:27'!
comanchePackages

	^OrderedCollection new
		add: komHttpServer	-> 'DynamicBindings-damiencassou.9.mcz';
		add: komHttpServer	-> 'KomServices-gc.19.mcz';
		add: komHttpServer	-> 'KomHttpServer-damiencassou.47.mcz';
			
		add: seaside30		-> 'Seaside-Adaptors-Comanche-lr.55.mcz';
		add: seaside30		-> 'Seaside-Tests-Adaptors-Comanche-lr.13.mcz';
		yourself.
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 3/15/2010 16:16'!
cometPackages

	^OrderedCollection new
		add: seaside30 -> 'Comet-Core-lr.49.mcz';
		add: seaside30 -> 'Comet-Pharo-Core-lr.6.mcz';
		add: seaside30 -> 'Comet-Tests-Core-lr.9.mcz';
		add: seaside30 -> 'Comet-Examples-lr.17.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'utility' stamp: 'jgf 2/6/2009 09:08'!
condenceChanges
"
	SeasideLoadOrderTests new condenseChanges.
"
	Smalltalk condenseChanges.
	! !

!SeasideLoadOrderTests methodsFor: 'accessing' stamp: 'obi 9/6/2009 20:48'!
currentVersions
	currentVersions ifNil: [currentVersions := MCWorkingCopy allManagers collect: [:ea |  ea ancestry ancestorString ]].
	^currentVersions! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'JamesFoster 11/1/2009 13:22'!
doLoad
	self requestUserAndPassword.
	self askForTesting.
	self cacheRepositories.
	self groups do: [:aList | 
		self 
			loadPackages: aList;
			doTests;
			yourself.
	].
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'JamesFoster 11/1/2009 13:23'!
doLoadNewest
	self askForTesting.
	self cacheRepositories.
	self groups do: [:aList | 
		self 
			loadNewestPackages: aList;
			doTests;
			yourself.
	].
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 16:12'!
doTests

	| suite result |
	doTests ifFalse: [^self].
	suite := TestCase suite.
	baseTests do: [:oldTest | 
		| duplicate |
		duplicate := suite tests detect: [:newTest | newTest class == oldTest class and: [newTest selector == oldTest selector]].
		suite tests remove: duplicate.
	].
	result := suite run.
	Transcript cr; tab; show: result printString.
	result defects do: [:each | 
		Transcript cr; tab; tab; show: each printString.
	].
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 3/15/2010 16:29'!
emailPackages

	^OrderedCollection new
		add: seaside30 -> 'Seaside-Email-lr.15.mcz';
		add: seaside30 -> 'Seaside-Tests-Email-lr.8.mcz';
		add: seaside30 -> 'Seaside-Pharo-Email-lr.6.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'private' stamp: 'obi 9/6/2009 20:34'!
extractPackageName: fullPackageName
	^(fullPackageName findTokens: '.') first copyUpToLast: $-! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 11/3/2009 07:56'!
groups

	^OrderedCollection new
		addAll: self basicPackages;
		addAll: self traditionalPackages;
		add: self adminToolsPackages;
		add: self rssPackages;
		add: self javascriptPackages;
		add: self jQueryPackages;
		add: self prototypePackages;
		add: self scriptaculousPackages;
		add: self htmlPackages;
		add: self internetExplorerPackages;
		add: self emailPackages;
		add: self comanchePackages;
		add: self cometPackages;
		yourself.
		! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 3/15/2010 16:30'!
htmlPackages

	^OrderedCollection new
		add: seaside30 -> 'Seaside-HTML5-lr.9.mcz';
		add: seaside30 -> 'Seaside-Tests-HTML5-pmm.17.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'initialize-release' stamp: 'obi 9/6/2009 20:22'!
initialize

	super initialize.
	userName := ''.
	password := ''.


	
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 3/15/2010 16:30'!
internetExplorerPackages

	^OrderedCollection new
		add: seaside30 -> 'Seaside-InternetExplorer-lr.6.mcz';
		add: seaside30 -> 'Seaside-Tests-InternetExplorer-lr.9.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'private' stamp: 'obi 9/6/2009 20:49'!
isPackageLoaded: aPackageName
	^self currentVersions includes: aPackageName! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 3/15/2010 16:18'!
jQueryPackages

	^OrderedCollection new
		add: seaside30 -> 'JQuery-Core-lr.103.mcz';
		add: seaside30 -> 'JQuery-Tests-Core-lr.113.mcz';
		add: seaside30 -> 'JQuery-UI-lr.53.mcz';
		add: seaside30 -> 'JQuery-Tests-UI-lr.73.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 3/15/2010 16:42'!
javascriptPackages

	^OrderedCollection new
		add: seaside30 -> 'Javascript-Core-lr.84.mcz';
		add: seaside30 -> 'Javascript-Pharo-Core-lr.7.mcz';
		add: seaside30 -> 'Javascript-Tests-Core-lr.54.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'repositories' stamp: 'jgf 2/6/2009 09:15'!
komHttpServer

	^MCHttpRepository
		location: 'http://www.squeaksource.com/KomHttpServer'
		user: userName
		password: password.
! !

!SeasideLoadOrderTests methodsFor: 'private' stamp: 'obi 9/6/2009 20:29'!
latestVersionForPackage: aName repository: repo
	| sortedVersions |
	sortedVersions := self sortedVersionsForPackage: aName repository: repo.
	^sortedVersions isEmpty
		ifTrue: [nil]
		ifFalse: [sortedVersions last]! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'obi 9/9/2009 21:34'!
loadNewestPackage: aString from: aRepository
	| packageName |
	packageName := self latestVersionForPackage: (self extractPackageName: aString) repository: aRepository.
	packageName ifNotNil: 
		[(self isPackageLoaded: packageName) ifFalse: [
				Transcript cr.
				packageName := packageName , '.mcz'.
				self loadPackage: packageName from: aRepository]]
	! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'obi 9/9/2009 21:34'!
loadNewestPackages: aList

	aList do: [:assoc |
		self
			loadNewestPackage: assoc value 
			from: assoc key.
	].
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'JamesFoster 12/15/2009 09:52'!
loadPackage: aString from: aRepository

	| version repositoryGroup transcript stream |
	version := aRepository loadVersionFromFileNamed: aString.
	transcript := Transcript.
	stream := WriteStream on: String new.
	[
		Transcript := stream.
		version load.
	] ensure: [
		Transcript := transcript.
	].
	false ifTrue: [self reportToTranscript: stream contents].
	repositoryGroup := version workingCopy repositoryGroup.
	repositoryGroup addRepository: aRepository.
	Transcript cr; show: 'Loaded ' , aString.
	self showUndeclared.
	! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 11:23'!
loadPackages: aList

	Transcript cr.
	aList do: [:assoc |
		self
			loadPackage: assoc value 
			from: assoc key.
	].
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 3/15/2010 16:19'!
prototypePackages

	^OrderedCollection new
		add: seaside30 -> 'Prototype-Core-lr.19.mcz';
		add: seaside30 -> 'Prototype-Tests-Core-lr.9.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'JamesFoster 12/15/2009 09:52'!
reportToTranscript: aString

	| list flag |
	list := aString subStrings: (Array with: $().
	list := list collect: [:each | each withBlanksTrimmed].
	list := list reject: [:each | each isEmpty].
	list := list reject: [:each | 
		16 < each size and: [ (each copyFrom: each size - 14 to: each size) = ' is Undeclared)'].
	].
	list isEmpty ifTrue: [^self].
	flag := true.
	1 to: list size - 1 by: 2 do: [:i | 
		flag := flag and: [(list at: i) = 'a MCClassDefinition'].
	].
	flag ifTrue: [^self].
	Transcript nextPutAll: aString.
	! !

!SeasideLoadOrderTests methodsFor: 'private' stamp: 'obi 9/6/2009 20:10'!
requestUserAndPassword
	userName := UIManager default
		request: 'SqueakSource User Name (empty is fine)?'
		initialAnswer: ''.
	password := UIManager default
		request: 'SqueakSource Password (empty is fine)?'
		initialAnswer: ''.
	! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 3/15/2010 16:20'!
rssPackages

	^OrderedCollection new
		add: seaside30 -> 'RSS-Core-lr.59.mcz';
		add: seaside30 -> 'RSS-Tests-Core-lr.22.mcz';
		add: seaside30 -> 'RSS-Examples-lr.24.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 3/15/2010 16:21'!
scriptaculousPackages

	^OrderedCollection new
		add: seaside30 -> 'Scriptaculous-Core-lr.96.mcz';
		add: seaside30 -> 'Scriptaculous-Tests-Core-lr.52.mcz';
		add: seaside30 -> 'Scriptaculous-Components-lr.99.mcz';
		add: seaside30 -> 'Scriptaculous-Tests-Components-lr.31.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'repositories' stamp: 'tbn 9/2/2009 23:10'!
seaside30

	^MCHttpRepository
		location: 'http://www.squeaksource.com/Seaside30'
		user: ''
		password: ''.
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 16:12'!
showUndeclared

	| newUndeclared |
	doTests ifFalse: [^self].
	newUndeclared := Undeclared keys.
	baseUndeclared do: [:each | newUndeclared remove: each].
	newUndeclared isEmpty ifTrue: [^self].
	Transcript cr; tab; show: 'Undeclared: ' , newUndeclared asSortedCollection asArray printString.
	! !

!SeasideLoadOrderTests methodsFor: 'private' stamp: 'obi 9/6/2009 19:59'!
sortedVersionsForPackage: aName repository: repo 
	| sortedVersions | 
	sortedVersions := ((versions at: repo ifAbsent: [#()]) select: [:versionName | | parts |
							parts := (aName occurrencesOf: $-) + 1.
							(versionName beginsWith: aName) and: [parts = (versionName occurrencesOf: $-) ] ])
								asSortedCollection: [:a :b | (a copyAfterLast: $.) asNumber <= (b copyAfterLast: $.) asNumber].
	sortedVersions isEmpty ifTrue: [self inform: 'No Version for ' , aName , ' found!!'. ^#() ].
	^sortedVersions! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 3/15/2010 16:36'!
traditionalPackages

	^OrderedCollection new
		"Functional Tests"	
		add: (Array 
			with: seaside30 -> 'Seaside-Tests-Functional-jf.118.mcz'
			with: seaside30 -> 'Seaside-Tests-Pharo-Functional-lr.11.mcz');
		"Continuations"
		add: (Array 
			with: seaside30 -> 'Seaside-Pharo-Continuation-lr.5.mcz'
			with: seaside30 -> 'Seaside-Tests-Pharo-Continuation-lr.6.mcz');
		"Flow"
		add: (Array 
			with: seaside30 -> 'Seaside-Flow-lr.21.mcz'
			with: seaside30 -> 'Seaside-Pharo-Flow-lr.5.mcz'
			with: seaside30 -> 'Seaside-Tests-Flow-lr.25.mcz');
		"WebTools"
		add: (Array 
			with: seaside30 -> 'Seaside-Tools-Web-lr.79.mcz'
			with: seaside30 -> 'Seaside-Pharo-Tools-Web-lr.21.mcz'
			with: seaside30 -> 'Seaside-Tests-Tools-Web-lr.14.mcz');
		"Development"
		add: (Array 
			with: seaside30 -> 'Seaside-Development-lr.133.mcz'
			with: seaside30 -> 'Seaside-Pharo-Development-lr.39.mcz'
			with: seaside30 -> 'Seaside-Tests-Development-lr.34.mcz'
			with: seaside30 -> 'Seaside-Tests-Pharo-Development-lr.9.mcz');
		"Examples"
		add: (Array 
			with: seaside30 -> 'Seaside-Examples-lr.17.mcz'
			with: seaside30 -> 'Seaside-Tests-Examples-lr.8.mcz');
			yourself.! !

!SeasideLoadOrderTests methodsFor: 'accessing' stamp: 'obi 9/6/2009 19:56'!
versions
	versions ifNil: [versions := Dictionary new].
	^versions! !
SeasideLoadOrderTests initialize!
